<?php
/*
Plugin Name: PL UTF-8 Notify Mail
Plugin URI: http://blog.serv.idv.tw/utf-8_mailheader_fix/
Description: A plugin that fix encoding issue in mail header when sending UTF-8 notify mail for post authors. The plugin is originated from AvP's <a href="http://www.quakemachine.com/blog/php/wordpress/554/" >UTF-8 Mail Header Fix</a> plugin. *** version 1.2+ requires WordPress 2.0 to function correctly. For WordPress 1.5, use version 1.1 instead ***
Author: PipperL
Version: 1.3
Author URI: http://blog.serv.idv.tw

Copyright 2005  PipperL  (email : pipperl@serv.idv.tw)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/


function filter_encode_utf8_mail_subject($content) {

	$content = '=?UTF-8?B?' . base64_encode($content) . '?=';
	return $content;
}

function filter_encode_utf8_mail_text($content) {

	$content = chunk_split(base64_encode($content));
	return $content;
}

function filter_encode_utf8_mail_headers($content) {

	$tmp_headers = split("\n", $content);
	$op_headers = array();
	foreach ($tmp_headers AS $key => $val  ) {
		# check each line in headers
		if (preg_match('/^From: \"(.+)\"(.*)$/', $val,$matches)) {
			$op_headers[] = 'From: "'. '=?UTF-8?B?' . base64_encode($matches[1]) 
							. '?="' . $matches[2];		    
		}
		elseif (preg_match('/^Content-Type:/', $val)) {
			$op_headers[] = $val . "\n" . 'Content-Transfer-Encoding: BASE64';		    
		}
		elseif (preg_match('/^Content-Transfer-Encoding: /', $val)) {
		    # discard original Content-Transfer-Encoding
			$op_headers[] = 'Content-Transfer-Encoding: BASE64';	
		}
		else {
		    $op_headers[] = $val;
		} // end if
	} // end foreach
	
	$content = join("\n", $op_headers);

	
  
    return $content;
}

add_filter('comment_notification_subject', 'filter_encode_utf8_mail_subject');
add_filter('comment_notification_text', 'filter_encode_utf8_mail_text');
add_filter('comment_notification_headers', 'filter_encode_utf8_mail_headers');
// add_filter('comment_moderation_subject', 'filter_encode_utf8_mail_subject');
// add_filter('comment_moderation_text', 'filter_encode_utf8_mail_text');
// add_filter('comment_moderation_headers', 'filter_encode_utf8_mail_headers');

?>